org.cpsolver.ifs.assignment.context

## Interface CanHoldContext

- All Known Implementing Classes:
    AbstractClassWithContext, AbstractCriterion, AssignedValue, AssignmentCount, AttributePreferences, BackToBack, BackToBackInstructorPreferences, BinaryConstraintWithContext, BreakFlexibleConstraint, BrokenTimePatterns, Config, ConstraintWithContext, Course, CoursePreferences, CourseRequest, CourseReservation, CurriculumOverride, CurriculumReservation, DbtPropagation, DeltaTimePreference, DepartmentBalancingPenalty, DepartmentSpreadConstraint, DifferentLecture, DiscouragedRoomConstraint, DistanceConflict, DistanceToStronglyPreferredRoom, DistributionPenalty, DistributionPreferences, DistributionViolation, DummyReservation, ExamConstruction, ExamCriterion, ExamDistributionConstraint, ExamGreatDeluge, ExamHillClimbing, ExamModel, ExamNeighbourSelection, ExamRoom, ExamRotationPenalty, ExamSimulatedAnnealing, ExamSplitter, ExamTabuSearch, ExtensionWithContext, FixCompleteSolutionNeighbourSelection, FlexibleConstraint, FlexibleConstraintCriterion, FreeTimeRequest, GreatDeluge, GroupConstraint, GroupReservation, HardConflicts, HillClimber, IgnoredCommittedStudentConflict, IgnoredStudentConflict, ImportantStudentConflict, ImportantStudentHardConflict, IndividualReservation, Instructor, InstructorBackToBackConflicts, InstructorConflict, InstructorConstraint, InstructorDirectConflicts, InstructorDistanceBackToBackConflicts, InstructorFairness, InstructorLunchBreak, InstructorMoreThan2ADayConflicts, InstructorNotAvailableConflicts, InstructorPreferences, InstructorSchedulingCriterion, InstructorStudentConflict, InstructorStudentHardConflict, JenrlConstraint, LargeExamsPenalty, LearningCommunityReservation, Lecture, MacPropagation, MacRevised, MaxBlockFlexibleConstraint, MaxBreaksFlexibleConstraint, MaxDaysFlexibleConstraint, MaxHalfDaysFlexibleConstraint, MaxHolesFlexibleConstraint, MaxWeeksFlexibleConstraint, MetaHeuristicSearch, MinimizeNumberOfUsedGroupsOfTime, MinimizeNumberOfUsedRoomsConstraint, ModelWithContext, NeighbourSearch, NeighbourSelectionWithContext, OnlineConfig, OnlineReservation, OnlineSection, OnlineSectioningModel, OriginalInstructor, ParallelConstruction, PeriodIndexPenalty, PeriodPenalty, PeriodSizePenalty, PeriodViolation, PerturbationPenalty, Perturbations, PlacementSelectionCriterion, PotentialHardConflicts, QuadraticStudentConflict, QuadraticStudentHardConflict, Request, RequestGroup, Reservation, ReservationOverride, Resource, ResourceConstraint, RoomConstraint, RoomPenalty, RoomPerturbationPenalty, RoomPreferences, RoomSizePenalty, RoomSizePenalty, RoomSplitDistancePenalty, RoomSplitPenalty, RoomViolation, RoomViolations, SameCommon, SameCourse, SameDays, SameInstructor, SameInstructorConstraint, SameLink, SameLinkConstraint, SameRoom, SameSubpartBalancingPenalty, SearchIntensification, Section, SimpleSearch, SimulatedAnnealing, SoftInstructorConstraint, SpreadConstraint, StepCountingHillClimber, StudentBackToBackConflicts, StudentCommittedConflict, StudentConflict, StudentDirectConflicts, StudentDistanceBackToBackConflicts, StudentDistanceConflict, StudentHardConflict, StudentLuchBreak, StudentMinimizeDaysOfWeek, StudentMinimizeScheduleHoles, StudentMoreThan1ADayConflicts, StudentMoreThan2ADayConflicts, StudentNotAvailableConflicts, StudentOverlapConflict, StudentOverLunchConflict, StudentQuality, StudentSectioningModel, StudentWorkdayConflict, TeachingPreferences, Test.TestModel, TimeOverlaps, TimeOverlapsCounter, TimePreferences, TimePreferences, TimetablingCriterion, TimeViolations, TooBigRooms, UnusedInstructorLoad, UselessHalfHours, VariableWithContext, WeightedHardConflicts

      public interface CanHoldContext

  An additional interface that can be implemented by the `HasAssignmentContext` class. The assignment context holder (see `AssignmentContextHolder`) can than use this interface to store assignment contexts directly on the `HasAssignmentContext` class, if the assignment permits it (the `Assignment.getIndex()` is implemented, i.e., a non negative index is returned).
  Version:
    IFS 1.3 (Iterative Forward Search)
    Copyright (C) 2014 Tomáš Müller
    muller@unitime.org
    http://muller.unitime.org
    This library is free software; you can redistribute it and/or modify it under the terms of the GNU Lesser General Public License as published by the Free Software Foundation; either version 3 of the License, or (at your option) any later version.
    This library is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more details.
    You should have received a copy of the GNU Lesser General Public License along with this library; if not see http://www.gnu.org/licenses.
  See Also:
    `HasAssignmentContext`

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `static int` | `sMaxSize` Maximum number of assignment contexts to be held

  - ### Method Summary

    All Methods Instance Methods Abstract Methods
    Modifier and Type | Method and Description
    --- | ---
    `AssignmentContext[]` | `getContext()` An array of `sMaxSize` assignment contexts

- - ### Field Detail

    - #### sMaxSize

          static final int sMaxSize

      Maximum number of assignment contexts to be held
      See Also:
        Constant Field Values

  - ### Method Detail

    - #### getContext

          AssignmentContext[] getContext()

      An array of `sMaxSize` assignment contexts
      Returns:
        assignment contexts